Subject: Re: gcj: error during genaration of object code (ld cannot find -liconv)
From: "Gerrit P. Haase" <[email-masked]>
To: Алексей Любимов <[email-masked]>
Cc: [email-masked]
Date: Fri, 18 Jun 2004 19:20:13 +0200

Hello Alexey,

> my question is: if I try to run `gcj' without `-C' option then I get the
> error from ld:

> $cat HelloWorldApp.java

> /**
>  * The HelloWorldApp class implements an application that
>  * simply displays "Hello World!" to the standard output.
>  */
> class HelloWorldApp {
>     public static void main(String[] args) {
>         System.out.println("Hello World!"); //Display the string.
>     }
> }

> $ gcj HelloWorldApp.java

> /usr/lib/gcc-lib/i686-pc-cygwin/3.3.1/../../../../i686-pc-cygwin/bin/ld:
> cannot find -liconv
> collect2: ld returned 1 exit status

> What does this mean? How to avoid the problem?
> Note: `$gcj -C HelloWoldApp.java' is Ok and generates HelloWorldApp.class.

You need to specify to gcj what it should do, obviously there is no
useful default setting.

If you specify `-C' the manpage says:

 -C  This option is used to tell gcj to generate bytecode (.class files)
           rather than object code.

I would expect that you get an error like this without specifying
anything:
$ gcj Foo.java
/usr/lib/gcc-lib/i686-pc-cygwin/3.3.1/../../../libcygwin.a(libcmain.o)(.text+0x7a): undefined reference to `_WinMain@16'
collect2: ld returned 1 exit status

Anyway, if you want to build an executable, you say s.th. like this:
  $ gcj --main=Foo -o Foo Foo.java
and to get bytecode you say:
  $ gcj -C Foo.java

Gerrit
-- 
=^..^=                                     http://nyckelpiga.de/donate.html

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/